const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Learning_coursesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const learning_courses = await db.learning_courses.create(
      {
        id: data.id || undefined,

        title: data.title || null,
        provider: data.provider || null,
        hours: data.hours || null,
        compliance_tag: data.compliance_tag || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await learning_courses.setOrganizations(data.organizations || null, {
      transaction,
    });

    return learning_courses;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const learning_coursesData = data.map((item, index) => ({
      id: item.id || undefined,

      title: item.title || null,
      provider: item.provider || null,
      hours: item.hours || null,
      compliance_tag: item.compliance_tag || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const learning_courses = await db.learning_courses.bulkCreate(
      learning_coursesData,
      { transaction },
    );

    // For each item created, replace relation files

    return learning_courses;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const learning_courses = await db.learning_courses.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.provider !== undefined) updatePayload.provider = data.provider;

    if (data.hours !== undefined) updatePayload.hours = data.hours;

    if (data.compliance_tag !== undefined)
      updatePayload.compliance_tag = data.compliance_tag;

    updatePayload.updatedById = currentUser.id;

    await learning_courses.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await learning_courses.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return learning_courses;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const learning_courses = await db.learning_courses.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of learning_courses) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of learning_courses) {
        await record.destroy({ transaction });
      }
    });

    return learning_courses;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const learning_courses = await db.learning_courses.findByPk(id, options);

    await learning_courses.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await learning_courses.destroy({
      transaction,
    });

    return learning_courses;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const learning_courses = await db.learning_courses.findOne(
      { where },
      { transaction },
    );

    if (!learning_courses) {
      return learning_courses;
    }

    const output = learning_courses.get({ plain: true });

    output.enrollment_learnings_course =
      await learning_courses.getEnrollment_learnings_course({
        transaction,
      });

    output.organizations = await learning_courses.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('learning_courses', 'title', filter.title),
        };
      }

      if (filter.provider) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'learning_courses',
            'provider',
            filter.provider,
          ),
        };
      }

      if (filter.compliance_tag) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'learning_courses',
            'compliance_tag',
            filter.compliance_tag,
          ),
        };
      }

      if (filter.hoursRange) {
        const [start, end] = filter.hoursRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            hours: {
              ...where.hours,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            hours: {
              ...where.hours,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.learning_courses.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('learning_courses', 'title', query),
        ],
      };
    }

    const records = await db.learning_courses.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
